INSTALL 10.1 KB
Newer Older
Michael Hanselmann's avatar
Michael Hanselmann committed
1 2
Ganeti quick installation guide
===============================
3

Michael Hanselmann's avatar
Michael Hanselmann committed
4 5 6
Please note that a more detailed installation procedure is described in
the :doc:`install`. A glossary of terms can be found in the
:doc:`glossary`.
7 8


9
Software Requirements
Michael Hanselmann's avatar
Michael Hanselmann committed
10
---------------------
Iustin Pop's avatar
Iustin Pop committed
11

12 13
.. highlight:: shell-example

Iustin Pop's avatar
Iustin Pop committed
14
Before installing, please verify that you have the following programs:
Michael Hanselmann's avatar
Michael Hanselmann committed
15

16 17 18 19 20
- `Xen Hypervisor <http://www.xen.org/>`_, version 3.0 or above, if
  running on Xen
- `KVM Hypervisor <http://www.linux-kvm.org>`_, version 72 or above, if
  running on KVM. In order to use advanced features, such as live
  migration, virtio, etc, an even newer version is recommended (qemu-kvm
21
  versions 0.11.X and above have shown good behavior).
Michael Hanselmann's avatar
Michael Hanselmann committed
22
- `DRBD <http://www.drbd.org/>`_, kernel module and userspace utils,
23 24 25
  version 8.0.7 or above; note that Ganeti doesn't yet support version 8.4
- `RBD <http://ceph.newdream.net/>`_, kernel modules
  (``rbd.ko``/``libceph.ko``) and userspace utils (``ceph-common``)
Michael Hanselmann's avatar
Michael Hanselmann committed
26 27 28 29 30
- `LVM2 <http://sourceware.org/lvm2/>`_
- `OpenSSH <http://www.openssh.com/portable.html>`_
- `bridge utilities <http://www.linuxfoundation.org/en/Net:Bridge>`_
- `iproute2 <http://www.linuxfoundation.org/en/Net:Iproute2>`_
- `arping <http://www.skbuff.net/iputils/>`_ (part of iputils)
31
- `ndisc6 <http://www.remlab.net/ndisc6/>`_ (if using IPv6)
Guido Trotter's avatar
Guido Trotter committed
32
- `Python <http://www.python.org/>`_, version 2.6 or above, not 3.0
Michael Hanselmann's avatar
Michael Hanselmann committed
33 34
- `Python OpenSSL bindings <http://pyopenssl.sourceforge.net/>`_
- `simplejson Python module <http://code.google.com/p/simplejson/>`_
35 36
- `pyparsing Python module <http://pyparsing.wikispaces.com/>`_, version
  1.4.6 or above
Michael Hanselmann's avatar
Michael Hanselmann committed
37
- `pyinotify Python module <https://github.com/seb-m/pyinotify>`_
38
- `PycURL Python module <http://pycurl.sourceforge.net/>`_
39 40
- `socat <http://www.dest-unreach.org/socat/>`_, see :ref:`note
  <socat-note>` below
41 42
- `Paramiko <http://www.lag.net/paramiko/>`_, if you want to use
  ``ganeti-listrunner``
43 44
- `affinity Python module <http://pypi.python.org/pypi/affinity/0.1.0>`_,
  optional python package for supporting CPU pinning under KVM
45
- `qemu-img <http://qemu.org/>`_, if you want to use ``ovfconverter``
46
- `fping <http://fping.sourceforge.net/>`_
47 48 49
- `Python IP address manipulation library
  <http://code.google.com/p/ipaddr-py/>`_
- `Bitarray Python library <http://pypi.python.org/pypi/bitarray/>`_
Michael Hanselmann's avatar
Michael Hanselmann committed
50 51 52 53 54

These programs are supplied as part of most Linux distributions, so
usually they can be installed via the standard package manager. Also
many of them will already be installed on a standard machine. On
Debian/Ubuntu, you can use this command line to install all required
55
packages, except for RBD, DRBD and Xen::
Michael Hanselmann's avatar
Michael Hanselmann committed
56 57

  $ apt-get install lvm2 ssh bridge-utils iproute iputils-arping \
58 59
                    ndisc6 python python-pyopenssl openssl \
                    python-pyparsing python-simplejson \
60 61
                    python-pyinotify python-pycurl socat fping \
                    python-ipaddr python-bitarray
62 63 64 65 66 67 68 69 70

Note that this does not install optional packages::

  $ apt-get install python-paramiko python-affinity qemu-img

If some of the python packages are not available in your system,
you can try installing them using ``easy_install`` command.
For example::

71
  $ apt-get install python-setuptools python-dev
72
  $ cd / && sudo easy_install \
73 74 75
            affinity \
            bitarray \
            ipaddr \
76

Michael Hanselmann's avatar
Michael Hanselmann committed
77

78 79 80 81
On Fedora to install all required packages except RBD, DRBD and Xen::

  $ yum install openssh openssh-clients bridge-utils iproute ndisc6 \
                pyOpenSSL pyparsing python-simplejson python-inotify \
82
                python-lxm socat fping python-bitarray python-ipaddr
83 84

For optional packages use the command::
85

86
  $ yum install python-paramiko python-affinity qemu-img
87

88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106
If you want to build from source, please see doc/devnotes.rst for more
dependencies.

.. _socat-note:
.. note::
  Ganeti's import/export functionality uses ``socat`` with OpenSSL for
  transferring data between nodes. By default, OpenSSL 0.9.8 and above
  employ transparent compression of all data using zlib if supported by
  both sides of a connection. In cases where a lot of data is
  transferred, this can lead to an increased CPU usage. Additionally,
  Ganeti already compresses all data using ``gzip`` where it makes sense
  (for inter-cluster instance moves).

  To remedey this situation, patches implementing a new ``socat`` option
  for disabling OpenSSL compression have been contributed and will
  likely be included in the next feature release. Until then, users or
  distributions need to apply the patches on their own.

  Ganeti will use the option if it's detected by the ``configure``
Iustin Pop's avatar
Iustin Pop committed
107
  script; auto-detection can be disabled by explicitly passing
108 109 110 111 112 113 114 115 116
  ``--enable-socat-compress`` (use the option to disable compression) or
  ``--disable-socat-compress`` (don't use the option).

  The patches and more information can be found on
  http://www.dest-unreach.org/socat/contrib/socat-opensslcompress.html.

Haskell requirements
~~~~~~~~~~~~~~~~~~~~

117 118 119
Starting with Ganeti 2.7, the Haskell GHC compiler and a few base
libraries are required in order to build Ganeti (but not to run and
deploy Ganeti on production machines). More specifically:
120

121
- `GHC <http://www.haskell.org/ghc/>`_ version 6.12 or higher
122 123 124 125 126 127
- or even better, `The Haskell Platform
  <http://hackage.haskell.org/platform/>`_ which gives you a simple way
  to bootstrap Haskell
- `json <http://hackage.haskell.org/package/json>`_, a JSON library
- `network <http://hackage.haskell.org/package/network>`_, a basic
  network library
128 129
- `parallel <http://hackage.haskell.org/package/parallel>`_, a parallel
  programming library (note: tested with up to version 3.x)
130 131 132
- `bytestring <http://hackage.haskell.org/package/bytestring>`_ and
  `utf8-string <http://hackage.haskell.org/package/utf8-string>`_
  libraries; these usually come with the GHC compiler
133
- `deepseq <http://hackage.haskell.org/package/deepseq>`_
134 135
- `curl <http://hackage.haskell.org/package/curl>`_, tested with
  versions 1.3.4 and above
136

Iustin Pop's avatar
Iustin Pop committed
137
Some of these are also available as package in Debian/Ubuntu::
138 139

  $ apt-get install ghc6 libghc6-json-dev libghc6-network-dev \
140 141
                    libghc6-parallel-dev libghc6-deepseq-dev \
                    libghc6-curl-dev
142

143
Or in newer versions of these distributions (using GHC 7.x)::
144

145
  $ apt-get install ghc libghc-json-dev libghc-network-dev \
146 147
                    libghc-parallel-dev libghc-deepseq-dev \
                    libghc-utf8-string-dev libghc-curl-dev
148

149
In Fedora, some of them are available via packages as well::
150

151 152
  $ yum install ghc ghc-json-devel ghc-network-devel \
                    ghc-parallel-devel ghc-deepseq-devel
153

154
If using a distribution which does not provide them, first install
155
the Haskell platform. You can also install ``cabal`` manually::
156 157 158 159

  $ apt-get install cabal-install

Then install the additional libraries via
160 161
``cabal``::

162
  $ cabal install json network parallel utf8-string curl
163

164 165 166 167
Haskell optional features
~~~~~~~~~~~~~~~~~~~~~~~~~

Optionally, more functionality can be enabled if your build machine has
168
a few more Haskell libraries enabled: the ``ganeti-confd`` daemon
169 170
(``--enable-confd``) and the monitoring daemon
(``--enable-mond``). The list of extra dependencies for these is:
171

172 173 174 175 176
- `hslogger <http://software.complete.org/hslogger>`_, version 1.1 and
  above (note that Debian Squeeze only has version 1.0.9)
- `Crypto <http://hackage.haskell.org/package/Crypto>`_, tested with
  version 4.2.4
- `text <http://hackage.haskell.org/package/text>`_
177 178
- `hinotify <http://hackage.haskell.org/package/hinotify>`_, tested with
  version 0.3.2
179 180
- `regex-pcre <http://hackage.haskell.org/package/regex-pcre>`_,
  bindings for the ``pcre`` library
181
- `attoparsec <http://hackage.haskell.org/package/attoparsec>`_
182
- `vector <http://hackage.haskell.org/package/vector>`_
183 184
- `snap-server` <http://hackage.haskell.org/package/snap-server>`_, version
  0.8.1 and above.
185

186 187
These libraries are available in Debian Wheezy (but not in Squeeze, with
the exception of curl), so you can use either apt::
188

189
  $ apt-get install libghc-hslogger-dev libghc-crypto-dev libghc-text-dev \
190
                    libghc-hinotify-dev libghc-regex-pcre-dev \
191 192
                    libghc-attoparsec-dev libghc-vector-dev \
                    libghc-snap-server-dev
193

194
or ``cabal``, after installing a required non-Haskell dependency::
195

196
  $ apt-get install libpcre3-dev
197
  $ cabal install hslogger Crypto text hinotify regex-pcre \
198
                  attoparsec vector snap-server
199

200
to install them.
201

202 203 204 205 206 207 208 209 210
In case you still use ghc-6.12, note that ``cabal`` would automatically try to
install newer versions of some of the libraries snap-server depends on, that
cannot be compiled with ghc-6.12, so you have to install snap-server on its
own, esplicitly forcing the installation of compatible versions::

  $ cabal install MonadCatchIO-transformers==0.2.2.0 mtl==2.0.1.0 \
                  hashable==1.1.2.0 case-insensitive==0.3 parsec==3.0.1 \
                  network==2.3 snap-server==0.8.1

211 212 213
The most recent Fedora doesn't provide ``crypto``, ``inotify``. So these
need to be installed using ``cabal``, if desired. The other packages can
be installed via ``yum``::
214 215 216 217

  $ yum install ghc-hslogger-devel ghc-text-devel \
                ghc-regex-pcre-devel

218 219 220 221 222 223 224 225
.. _cabal-note:
.. note::
  If one of the cabal packages fails to install due to unfulfilled
  dependencies, you can try enabling symlinks in ``~/.cabal/config``.

  Make sure that your ``~/.cabal/bin`` directory (or whatever else
  is defined as ``bindir``) is in your ``PATH``.

226
Installation of the software
Michael Hanselmann's avatar
Michael Hanselmann committed
227 228 229
----------------------------

To install, simply run the following command::
Iustin Pop's avatar
Iustin Pop committed
230

231 232 233
  $ ./configure --localstatedir=/var --sysconfdir=/etc && \
    make && \
    make install
Iustin Pop's avatar
Iustin Pop committed
234

Michael Hanselmann's avatar
Michael Hanselmann committed
235 236 237 238
This will install the software under ``/usr/local``. You then need to
copy ``doc/examples/ganeti.initd`` to ``/etc/init.d/ganeti`` and
integrate it into your boot sequence (``chkconfig``, ``update-rc.d``,
etc.).
Iustin Pop's avatar
Iustin Pop committed
239

240

Iustin Pop's avatar
Iustin Pop committed
241
Cluster initialisation
Michael Hanselmann's avatar
Michael Hanselmann committed
242
----------------------
Iustin Pop's avatar
Iustin Pop committed
243

Michael Hanselmann's avatar
Michael Hanselmann committed
244 245
Before initialising the cluster, on each node you need to create the
following directories:
Iustin Pop's avatar
Iustin Pop committed
246

Michael Hanselmann's avatar
Michael Hanselmann committed
247 248 249 250 251 252
- ``/etc/ganeti``
- ``/var/lib/ganeti``
- ``/var/log/ganeti``
- ``/srv/ganeti``
- ``/srv/ganeti/os``
- ``/srv/ganeti/export``
Iustin Pop's avatar
Iustin Pop committed
253 254

After this, use ``gnt-cluster init``.
Michael Hanselmann's avatar
Michael Hanselmann committed
255 256 257 258 259 260

.. vim: set textwidth=72 syntax=rst :
.. Local Variables:
.. mode: rst
.. fill-column: 72
.. End: